/*******************************************************************************
 * Copyright (c) 2009 TopQuadrant, Inc.
 * All rights reserved. 
 *******************************************************************************/
package org.topbraid.spin.inference;

import java.util.HashMap;
import java.util.Map;

import com.hp.hpl.jena.graph.Triple;


/**
 * A service that can be used to provide "explanations" of inferred
 * triples.  This is populated by the TopSPIN engine and will keep
 * a Map from Triples to the strings of the query.
 * 
 * @author Holger Knublauch
 */
public class SPINExplanations {

	private Map<Triple, String> map = new HashMap<Triple, String>();
	
	
	/**
	 * Stores a Triple - query assignment.
	 * @param triple  the inferred Triple
	 * @param text  the query text to associate with the triple
	 */
	public void put(Triple triple, String text) {
		map.put(triple, text);
	}
	
	
	/**
	 * Gets the explanation for a given inferred triple.
	 * @param triple  the Triple to explain
	 * @return the explanation or null if none found for triple
	 */
	public String get(Triple triple) {
		return map.get(triple);
	}
}
